/* mixer control routines for *amfm - Linux interface for
   GemTek based radio module(ex. Justy Radion-maru) attached to a serial port.
   The bulk of following code was by Chris Radek.
   but lightly modified by Atsushi Umeshima <ume@tka.att.ne.jp>
   see *amfm.c for GNU copyleft statement */

#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <fcntl.h>
#include <unistd.h>
#include <sys/ioctl.h>
#include <sys/soundcard.h>

int openmixer(void) {
  int fd;

  fd = open("/dev/mixer", O_RDWR);
  if (fd<0) perror("open");
  return fd;
}

void setvolume(int fd, int value) {
  value = (value<<8)|value;
  if (fd>=0)
  {
      if (ioctl(fd, SOUND_MIXER_WRITE_LINE, &value)<0) perror("ioctl write");
  }
}

int getvolume(int fd) {
  int value;
  if (fd>=0)
  {
      if (ioctl(fd, SOUND_MIXER_READ_LINE, &value)<0) perror("ioctl read");
  } else {
      value = 0;
  }
  return ( ((value&0xff)+(value>>8)) /2 );
}

void closemixer(int fd) {
  if (fd>=0)
  {
      close(fd);
  }
}

void addrecsrc(int fd, int src) {
  int value;
    
  if (fd>=0)
  {
      if (ioctl(fd, SOUND_MIXER_READ_RECSRC, &value)<0) perror("ioctl read");
      value |= (1<<src);
      if (ioctl(fd, SOUND_MIXER_WRITE_RECSRC, &value)<0) perror("ioctl write");
  }
}
